/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.readers.ReadFluent;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Arrays;
import java.util.Comparator;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.system.main.VisNow;
import static org.visnow.vn.lib.basic.readers.ReadFluent.ReadFluentShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private final JFileChooser dataFileChooser = new JFileChooser();
    private final FileNameExtensionFilter dataFilter;
    private Parameters parameters;
    private String lastPath = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        moduleLabel.setText("ANSYS Fluent reader");
        dataFilter = new FileNameExtensionFilter("ANSYS Fluent case file (*.cas)", "cas", "CAS");
        dataFileChooser.setFileFilter(dataFilter);
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }
    
    protected void updateGUI(final ParameterProxy p)
    {
        displayCB.setSelected(p.get(SHOW));
        scaleSlider.setValue(p.get(SCALE));
        fileNameField.setText(p.get(CAS_FILE_PATH));
        rescaleCB.setSelected(p.get(SCALE) != 1.0);
        scaleSlider.setEnabled(rescaleCB.isSelected());    
        cellToNodeCB.setSelected(p.get(CELL_TO_NODE));
        dropCellDataCB.setSelected(p.get(DROP_CELL_DATA));
        dropConstantCB.setSelected(p.get(DROP_CONSTANT_DATA));       
        rereadButton.setEnabled(p.get(CAS_FILE_PATH) != null && !p.get(CAS_FILE_PATH).isEmpty());
        updateCheckboxes();
    }


    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        selectButton = new javax.swing.JButton();
        fileNameField = new javax.swing.JTextField();
        moduleLabel = new javax.swing.JLabel();
        rereadButton = new javax.swing.JButton();
        scaleSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        dropConstantCB = new javax.swing.JCheckBox();
        rescaleCB = new javax.swing.JCheckBox();
        cellToNodeCB = new javax.swing.JCheckBox();
        dropCellDataCB = new javax.swing.JCheckBox();
        displayCB = new javax.swing.JCheckBox();
        mergeCellSetsCB = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        fieldDescription = new javax.swing.JLabel();
        mergeCellSetsCB = new javax.swing.JCheckBox();

        setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        setMinimumSize(new java.awt.Dimension(180, 500));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        selectButton.setText("browse");
        selectButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        selectButton.setMaximumSize(new java.awt.Dimension(90, 20));
        selectButton.setMinimumSize(new java.awt.Dimension(90, 20));
        selectButton.setPreferredSize(new java.awt.Dimension(90, 20));
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        add(selectButton, gridBagConstraints);

        fileNameField.setMinimumSize(new java.awt.Dimension(4, 20));
        fileNameField.setPreferredSize(new java.awt.Dimension(4, 22));
        fileNameField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                fileNameFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 1, 0);
        add(fileNameField, gridBagConstraints);

        moduleLabel.setText("module");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(moduleLabel, gridBagConstraints);

        rereadButton.setText("reread");
        rereadButton.setEnabled(false);
        rereadButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        rereadButton.setMaximumSize(new java.awt.Dimension(90, 20));
        rereadButton.setMinimumSize(new java.awt.Dimension(90, 20));
        rereadButton.setPreferredSize(new java.awt.Dimension(90, 20));
        rereadButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                rereadButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 0, 0);
        add(rereadButton, gridBagConstraints);

        scaleSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        scaleSlider.setGlobalMin(new Float(0.0f));
        scaleSlider.setMax(new Float(1000));
        scaleSlider.setMin(new Float(0.1));
        scaleSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        scaleSlider.setShowingFields(true);
        scaleSlider.setValue(new Float(1));
        scaleSlider.setEnabled(false);
        scaleSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                scaleSliderUserAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(scaleSlider, gridBagConstraints);

        dropConstantCB.setSelected(true);
        dropConstantCB.setText("drop constant components");
        dropConstantCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                dropConstantCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(dropConstantCB, gridBagConstraints);

        rescaleCB.setText("rescale geometry:");
        rescaleCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                rescaleCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(rescaleCB, gridBagConstraints);

        cellToNodeCB.setSelected(true);
        cellToNodeCB.setText("convert cell data to node data");
        cellToNodeCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cellToNodeCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(cellToNodeCB, gridBagConstraints);

        dropCellDataCB.setSelected(true);
        dropCellDataCB.setText("drop cell data");
        dropCellDataCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                dropCellDataCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(dropCellDataCB, gridBagConstraints);

        displayCB.setSelected(true);
        displayCB.setText("show");
        displayCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                displayCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(displayCB, gridBagConstraints);

        mergeCellSetsCB.setSelected(true);
        mergeCellSetsCB.setText("merge cell sets");
        mergeCellSetsCB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mergeCellSetsCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(mergeCellSetsCB, gridBagConstraints);

        fieldDescription.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        fieldDescription.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        fieldDescription.setMaximumSize(null);
        fieldDescription.setMinimumSize(new java.awt.Dimension(200, 600));
        fieldDescription.setPreferredSize(null);
        jScrollPane1.setViewportView(fieldDescription);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jScrollPane1, gridBagConstraints);

        mergeCellSetsCB.setSelected(true);
        mergeCellSetsCB.setText("merge cell sets");
        mergeCellSetsCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                mergeCellSetsCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(mergeCellSetsCB, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        String fileName = null;
        if (lastPath == null)
            dataFileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(ReadFluent.class)));
        else
            dataFileChooser.setCurrentDirectory(new File(lastPath));

        int returnVal = dataFileChooser.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            fileName = dataFileChooser.getSelectedFile().getAbsolutePath();
            lastPath = fileName.substring(0, fileName.lastIndexOf(File.separator));
            VisNow.get().getMainConfig().setLastDataPath(lastPath, ReadFluent.class);
            rereadButton.setEnabled(true);
            fileNameField.setText(fileName);
            processCasFileSelection(fileName);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    private void rereadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rereadButtonActionPerformed
        parameters.fireParameterChanged(null);
    }//GEN-LAST:event_rereadButtonActionPerformed

    private void displayCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_displayCBActionPerformed
    {//GEN-HEADEREND:event_displayCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(SHOW, displayCB.isSelected());
        parameters.setParameterActive(true);

    }//GEN-LAST:event_displayCBActionPerformed

    private void fileNameFieldActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_fileNameFieldActionPerformed
    {//GEN-HEADEREND:event_fileNameFieldActionPerformed
        processCasFileSelection(fileNameField.getText());
    }//GEN-LAST:event_fileNameFieldActionPerformed

    private void scaleSliderUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_scaleSliderUserAction
        parameters.setParameterActive(false);
        parameters.set(SCALE, (Float) scaleSlider.getValue());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_scaleSliderUserAction

    private void rescaleCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rescaleCBActionPerformed
        scaleSlider.setEnabled(rescaleCB.isSelected());
        parameters.setParameterActive(false);
        if (rescaleCB.isSelected()) {
            parameters.set(SCALE, (Float) scaleSlider.getValue());
        } else {
            parameters.set(SCALE, 1.0f);
        }
        parameters.setParameterActive(true);
    }//GEN-LAST:event_rescaleCBActionPerformed

    private void cellToNodeCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cellToNodeCBActionPerformed
    {//GEN-HEADEREND:event_cellToNodeCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(CELL_TO_NODE, cellToNodeCB.isSelected());
        updateCheckboxes();
        parameters.setParameterActive(true);
    }//GEN-LAST:event_cellToNodeCBActionPerformed

    private void dropCellDataCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_dropCellDataCBActionPerformed
    {//GEN-HEADEREND:event_dropCellDataCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(DROP_CELL_DATA, dropCellDataCB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_dropCellDataCBActionPerformed

    private void dropConstantCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dropConstantCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(DROP_CONSTANT_DATA, dropConstantCB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_dropConstantCBActionPerformed

    private void mergeCellSetsCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mergeCellSetsCBActionPerformed
    {//GEN-HEADEREND:event_mergeCellSetsCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(MERGE_CELL_SETS, mergeCellSetsCB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_mergeCellSetsCBActionPerformed

    private void processCasFileSelection(String casPath)
    {
        parameters.setParameterActive(false);
        parameters.set(CAS_FILE_PATH, casPath);
        parameters.setParameterActive(true);
        
        if(casPath == null || casPath.isEmpty()) {
            parameters.set(DAT_FILE_PATHS, new String[0]);
            return;
        }

        String dirPath = casPath.substring(0, casPath.lastIndexOf(File.separator));
        final String prefix = casPath.substring(dirPath.length() + 1, casPath.length() - 4);
        File dir = new File(dirPath);
        String[] ls = dir.list(new FilenameFilter()
        {
            @Override
            public boolean accept(File dir, String name)
            {
                return name.startsWith(prefix) && name.endsWith(".dat");
            }
        });

        if (ls != null && ls.length > 1) {
            //more than one dat file - show frame with dat file selection
            Arrays.sort(ls, new Comparator<String>()
            {
                @Override
                public int compare(String o1, String o2)
                {
                    return getFileId(o1).compareTo(getFileId(o2));
                }

                private Long getFileId(String filePath)
                {
                    String[] token = filePath.split("\\.");
                    if (token.length == 0) {
                        return -1l;
                    }
                    String fileName = token[0];
                    StringBuilder fileId = new StringBuilder();

                    for (int i = fileName.length() - 1; i >= 0; i--) {
                        if (Character.isDigit(fileName.charAt(i))) {
                            fileId.append(fileName.charAt(i));
                        }
                    }
                    if (fileId.length() == 0) {
                        return -1l;
                    }
                    long res;
                    try {
                        res = Long.parseLong(fileId.reverse().toString());
                    } catch (NumberFormatException ex) {
                        res = -1;
                    }
                    return res;
                }
            }
            );
            DatFileChooser datChooser = new DatFileChooser();
            datChooser.setDatFiles(ls);
            datChooser.centerOnScreen();
            datChooser.setVisible(true);
            if (datChooser.isAccepted()) {
                String[] selection = datChooser.getSelectedDatFiles();
                if (selection != null)
                    for (int i = 0; i < selection.length; i++) {
                        selection[i] = dirPath + File.separator + selection[i];
                    }
                parameters.set(DAT_FILE_PATHS, selection);
            }
        } else if (ls != null && ls.length == 1) {
            ls[0] = dirPath + File.separator + ls[0];
            parameters.set(DAT_FILE_PATHS, ls);
        } else {
            parameters.set(DAT_FILE_PATHS, new String[0]);
        }
    }

    public void setFieldDescription(String s)
    {
        fieldDescription.setText(s);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cellToNodeCB;
    private javax.swing.JCheckBox displayCB;
    private javax.swing.JCheckBox dropCellDataCB;
    private javax.swing.JCheckBox dropConstantCB;
    private javax.swing.JLabel fieldDescription;
    private javax.swing.JTextField fileNameField;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox mergeCellSetsCB;
    private javax.swing.JLabel moduleLabel;
    private javax.swing.JButton rereadButton;
    private javax.swing.JCheckBox rescaleCB;
    private org.visnow.vn.gui.widgets.ExtendedSlider scaleSlider;
    private javax.swing.JButton selectButton;
    // End of variables declaration//GEN-END:variables
  

    public String getLastPath()
    {
        return lastPath;
    }

    void activateOpenDialog()
    {
        selectButtonActionPerformed(null);
    }

    private void updateCheckboxes() {
        dropCellDataCB.setEnabled(cellToNodeCB.isSelected());
        if(!dropCellDataCB.isEnabled()) {
            dropCellDataCB.setSelected(false);
        } else {
            dropCellDataCB.setSelected(parameters.get(DROP_CELL_DATA));
        }
    }
}
